/* Claudia Pietrus
Does My Breath Stink?
When the button is pressed, the LED will light up for 10 seconds
if the pressure sensor reads below the prescribed value.
If more (simulating someone blowing hard on the sensor), the
LED will stay on and a random integer 1-7 will 
cause the the positional servo to randomly 
move by a specific increment (averaged to about 22.5 degrees), stay there for 
10 seconds, then the LED will turn off and the servo move back to zero.
*/

// importing required libraries
#include <Servo.h>
#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BMP085_U.h>

// declaring variables
int buttonState = 0; // button initially "off"
double math = 0; // random variable
int pos = -90; // starting position of servo
int post = 0; // will store pos
int ran = 0; // integer of math
short pre = 0; // pressure reading
int pVal = 1000; // pressure threshold (atmospheric is around 991, and a human can generate 7 hPa by blowing hard)
Adafruit_BMP085_Unified bmp = Adafruit_BMP085_Unified(10085); // setting up the pressure sensor

Servo servo_9; // introducing servo

void setup()
{
  
  Serial.begin(9600); // activating serial monitor 
  bmp.begin(); // beginning pressure sensor
  
  // button and LED input and output
  pinMode(2, INPUT);
  pinMode(3, OUTPUT);
  
  // servo pin and parameters
  servo_9.attach(9, 500, 2500);
 
}

void loop()
{
  // read the state of the button value
  buttonState = digitalRead(2);

  // create a sensor event and store in variable pre
  sensors_event_t event;
  bmp.getEvent(&event);
  pre = event.pressure;

  // check pressure reading
  Serial.print(" Pressure: ");
  Serial.print(pre);

  
  // check if button is pressed. if yes, buttonState is HIGH
  if (buttonState == HIGH) {
   
    // turn LED on
    digitalWrite(3, HIGH);
    
    // turn off after 10s if pressure reading is too low
    if (pre <= pVal){
      delay(10000);}
  } 
  else {
    
    // turn LED off
    digitalWrite(3, LOW);
  }
  
  delay(10); // Delay a little bit
  
  
  // if button is pushed and pot is high enough, move the servo
  if (buttonState == HIGH) {

delay(5000); // give the user 5 seconds to blow

  if (pre > pVal) { // check if reading is above threshold
    
    math = rand() % 6+1; // generates a random number between 1 and 7
    ran = int(math); // convert to integer
      
    // sweep the servo from 0 to 22 degrees in steps of 1 degrees
    for (pos = 0; pos <= 22; pos += 1) {
    // tell servo to go to position in variable 'pos'
    servo_9.write(pos);
    // wait 15 ms for servo to reach the position
    delay(15); }// Wait for 15 ms

    
    if (ran < 7) {
        // continue sweep to 45 if ran isn't 7
        for (pos = 22; pos <= 45; pos += 1) {                           
      servo_9.write(pos);
      delay(15); } 
      
      if (ran < 6) {
            // continue sweep to 67 if ran isn't 7 or 6
        for (pos = 45; pos <= 67; pos += 1) {
        servo_9.write(pos);
        delay(15); }
        
        if(ran < 5) {
                // continue sweep to 90 if ran isn't 7, 6, or 5
          for (pos = 67; pos <= 90; pos += 1) {
          servo_9.write(pos);
          delay(15); }
          
          if (ran < 4) {
                    // sweep to 112 if ran isn't 7, 6, 5, or 4
            for (pos = 90; pos <= 112; pos += 1) {
            servo_9.write(pos);
              delay(15); }
            
            if (ran < 3) {
                        // sweep to 135 if ran is 1 or 2
              for (pos = 112; pos <= 135; pos += 1) {
              servo_9.write(pos);
                  delay(15); }
              
              if (ran < 2) {
                      // sweep to 157 if ran is 1
                      for (pos = 135; pos <= 157; pos += 1) {
                servo_9.write(pos);
                      delay(15); }
                
                }}}}}}


 delay(10000); // wait 10 seconds to read the insult
 post = pos; // store pos value

    // returning servo to initial position
    for (post = pos; post >= 0; post -= 1) {
      
    // tell servo to go to position in variable 'post'
    servo_9.write(post);
    // wait 15 ms for servo to reach the position
    delay(15); // Wait for 15 millisecond(s)
  
  }}}}
 
